/*****************************************************************************

  FileInOut

  Functions for input and output of data from and to ASCII Files.
  This an optional class and is not necessary for using Funplot.

  $Name: Funplot_v10 $
  $Revision: 1.5 $
  $Date: 2006/03/23 11:05:26 $

  Copyright (C) 1998-2006 Domenico Reggio, Software-Engineering

*******************************************************************************/

#ifndef FILEINOUT_H
#define FILEINOUT_H


#include <stdio.h>


class FileIn
{
public:
  int   Open(char *fileName);
  void  Close(void);
  int   ReadSignificantLine(void);
  int   CountValues(void);
  int   Get(long &val);
  int   Get(double &val);
  int   Get(char *&word, int &length);
  int   Get(char *word);
  int   GetString(char *word);  // Get's a string in single quotes
  long  GetLineNumber(void);
  char* GetLine(void);
  char* GetFileName(void);

private:
  FILE *stream;            // file pointer
  char *linePtr;           // pointer to position in line
  char *fileName;          // filename including path and extension
  char *line;              // input string
  long lineNumber;         // current line number
  bool endOfFileFlag;      // flags if end of file eeached

  int  ReadLine(void);
  int  EmptyLine(void);
};


class FileOut
{
public:
  int  Open(char* fileName="out.dat");
  void Close(void);
  void Set(int updateRate, char sep='\t', int spaceBegin=0);
  void NewLine(void);
  void Put(double number, int preDigits, int afterDigits);
  void Put(double number);
  void Put(int number);
  void Put(long int number);
  void Put(unsigned long int number);
  void Put(unsigned long int number, int digits);
  void Put(char *str);
  void PutString(char *str);  // Puts word in single quotes
  void PutLine(char *str);

private:
  int  timer,updateRate,spaceBegin,newLine;
  FILE *fptr;
  char sep;
  char *fileName;

  void NewLineCheck(void);
};

// Tips for Output Digits:  [] 4,9;  [m] 10,3;  [s] 8,3;  [rad] 2,11;
//                          [km] 7,6; [m/s] 6,7; [m/s2] 3,10;


#endif
